#ifndef SPARROWBOT_H
#define SPARROWBOT_H

#include "user.h"
#include "message.h"
#include <QObject>

class SparrowBot : public QObject
{
    Q_OBJECT

    enum{OFFLINE, ONLINE, ON_CHAN};

    QString nick;
    QString chan;
    int status;
    UserList users;

    // custom variables
    bool isInGame;
public:
    SparrowBot() : nick("SparrowBot"), chan("epicsparrow"), status(OFFLINE), isInGame(false) {}
    SparrowBot(QString nick_, QString chan_) : nick(nick_), chan(chan_), status(OFFLINE), isInGame(false) {}

private:
    void handleMessage(Message msg);
    void say(QString str);
    void whois(QString nick);
    void action(QString str);

public slots:
    void receiveMsg(QString msg);
    void disconnect();
    void disconnect(QString str);

signals:
    void sendMsg(QString msg);
    void changeSocketStatus(int newStatus);

private:
    // custom methods
    void joinGame();
};

#endif // SPARROWBOT_H
